﻿Imports System.Collections

Namespace PeopleNS

    Public Class PersonCollection
        Implements IEnumerator, IEnumerable

        Public Sub New()
            people = New People
            personArrayList = people.GetPeople(1500)
        End Sub

        Private currentIndex As Integer = -1
        Private people As People
        Private personArrayList As ArrayList


        Default ReadOnly Property Indexer(ByVal index As Integer) As Object
            Get
                Return personArrayList(index)
            End Get
        End Property


        Public ReadOnly Property Count() As Integer
            Get
                Return personArrayList.Count
            End Get
        End Property


        Public ReadOnly Property Current() As Object Implements IEnumerator.Current
            Get
                Dim personList As ArrayList = people.GetPeople(1500)

                Return personList(currentIndex)
            End Get
        End Property

        Public Function MoveNext() As Boolean Implements IEnumerator.MoveNext
            currentIndex += 1

            If currentIndex < 1500 Then
                Return True
            End If

            Return False
        End Function

        Public Sub Reset() Implements IEnumerator.Reset
            currentIndex = 0
        End Sub

        Public Function GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
            Return Me
        End Function
    End Class

End Namespace

