﻿Imports Person.PersonInformationNS

Imports Microsoft.VisualStudio.TestTools.UnitTesting

Imports People.PeopleNS



'''<summary>
'''This is a test class for PeopleTest and is intended
'''to contain all PeopleTest Unit Tests
'''</summary>
<TestClass()> _
Public Class PeopleTest


    Private testContextInstance As TestContext

    '''<summary>
    '''Gets or sets the test context which provides
    '''information about and functionality for the current test run.
    '''</summary>
    Public Property TestContext() As TestContext
        Get
            Return testContextInstance
        End Get
        Set(ByVal value As TestContext)
            testContextInstance = Value
        End Set
    End Property

#Region "Additional test attributes"
    '
    'You can use the following additional attributes as you write your tests:
    '
    'Use ClassInitialize to run code before running the first test in the class
    '<ClassInitialize()>  _
    'Public Shared Sub MyClassInitialize(ByVal testContext As TestContext)
    'End Sub
    '
    'Use ClassCleanup to run code after all tests in a class have run
    '<ClassCleanup()>  _
    'Public Shared Sub MyClassCleanup()
    'End Sub
    '
    'Use TestInitialize to run code before running each test
    '<TestInitialize()>  _
    'Public Sub MyTestInitialize()
    'End Sub
    '
    'Use TestCleanup to run code after each test has run
    '<TestCleanup()>  _
    'Public Sub MyTestCleanup()
    'End Sub
    '
#End Region


    '''<summary>
    '''A test for FindPersonInformationTest
    '''</summary>
    <TestMethod()> _
    Public Sub FindPersonInformationTest()
        Dim target As People.PeopleNS.People = New People.PeopleNS.People
        Dim number As Integer = 1500
        Dim firstName As String = "Katrina"
        Dim expected As PersonInformation = New PersonInformation("Brewer, Katrina", "The Phone Company")
        Dim actual As PersonInformation

        Dim before As DateTime = DateTime.Now
        actual = target.FindPersonInformation(firstName)
        Dim after As DateTime = DateTime.Now

        Assert.AreEqual(expected.FullName, actual.FullName)
        Assert.AreEqual(expected.Employer, actual.Employer)

        Dim duration As TimeSpan = after - before
        Assert.IsTrue(duration.TotalMilliseconds < 1000)

    End Sub
End Class
